package rndclub.game.shinkyoungshoiyak;

import java.awt.*;

// ٿε ¸ ֱ  ̾α â 
//  XP  â Frame   Ƿ
class LoadingBarWindow extends Frame {
   Label messageLabel=null;   // ٿε  ޽
   ImageCanvas logo=null;     // ٿε  ΰ ̹
   ProgressiveBar loadingBar=null;   // ٿε ¹

   public LoadingBarWindow(Image logoImage, String message) {
      //  XP  â Frame   Ƿ
//      super(owner, "ٿε º", false);  // Ŭ üڸ
                                                 // ݵ ȣ ־ 

      setTitle("ٿε º");

      setLayout(new BorderLayout(4, 4));
      setBackground(Color.black);

      // ΰ ֱ  ̹ Ʈ 
      logo = new ImageCanvas(0, logoImage);
      logo.setSize(logoImage.getWidth(logo), logoImage.getHeight(logo));
      logo.setState(ImageCanvas.STATE_FRONT);

      Panel logoPanel = new Panel();
      logoPanel.add(logo);

      // ޽ ֱ  ̺ Ʈ 
      messageLabel = new Label(message);
      messageLabel.setBackground(Color.lightGray);

      // ε ¸ ֱ  ¹ 
      loadingBar = new ProgressiveBar(100);
      Panel barPanel = new Panel();
      barPanel.add(loadingBar);

      Panel statusPanel = new Panel(new BorderLayout(4, 4));
      statusPanel.add("North", messageLabel);
      statusPanel.add("Center", barPanel);

      add("Center", logoPanel);
      add("South", statusPanel);

      pack();  //  ũ⸦ ȭ
      setSize(getSize().width+16, getSize().height+8); //  ϱ 
      autoAlign();   // 츦 ũ ߾ ġŲ.
   }

   //  ٿε â ° Ѵ.
   public void setStatusLevel(int statusLevel) {
      loadingBar.setTime(statusLevel);
   }

   //  ٿε â ޽ Ѵ.
   public void setMessage(String message) {
      messageLabel.setText(message);
   }

   //  ٿε â ΰ ̹ Ѵ.
   public void setLogo(Image logoImage) {
      logo.setImage(logoImage);
   }

   //  ٿε â ũ ߾ ġŲ.
   public void autoAlign() {
      Toolkit toolkit = Toolkit.getDefaultToolkit();

      int x = (toolkit.getScreenSize().width - getSize().width) / 2;
      int y = (toolkit.getScreenSize().height - getSize().height) / 2;

      setLocation(x, y);
   }
}
