/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

package rndclub.game.godori;
import java.awt.*;
import java.awt.event.*;

import java.util.StringTokenizer;

//  ʴϱ  ̾α â̴.
// ʴϰ ϴ    "ʴϱ" ư Ŭϰų, 
// Ǵ 츦 ݰ ׳   ִ.
class InvitationDialog extends Dialog {
   List playerList=null;
   Label invitationMsg=null;
   Button invitationButton=null, exitButton=null;
   GClient sender=null;
   String playerIdx=null;

   public InvitationDialog(Frame owner, GClient client, String playerId, String idList) {
      super(owner, "ʴϱ â", false);

      setLayout(new BorderLayout());

      sender = client;
      playerIdx = playerId;

      invitationMsg = new Label("ʴ  ϼ..", Label.LEFT);
      invitationMsg.setBackground(new Color(31,119,0));
      invitationMsg.setForeground(new Color(255,255,255));
      invitationButton = new Button("ʴϱ");
      invitationButton.setBackground(new Color(184,184,218));
      exitButton = new Button("");
      exitButton.setBackground(new Color(184,184,218));
      playerList = new List();

      try {
         StringTokenizer tokenizer = new StringTokenizer(idList, ",");
         while(tokenizer.hasMoreTokens()) {
            String id = tokenizer.nextToken();

            playerList.add(id);
         }
      } catch(Exception ee) {
      }

      Panel commandPanel = new Panel();
      commandPanel.add(invitationButton);
      commandPanel.add(exitButton);

      add("North", invitationMsg);
      add("Center", playerList);
      add("South", commandPanel);

      // ʴ  ̵ Է  ʴϱ ư Ŭ ,
      // ش 濡 "ʴ" ޽ .
      ActionListener al = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            if((e.getSource() == invitationButton) ||
               (e.getSource() == playerList)) {
               if(playerList.getSelectedItem() != null) {
                  String message = "586|" + playerIdx
                                 + "|" + playerList.getSelectedItem();

                  sender.sendToServer(message);

                  dispose();
               }
            }
         }
      };
      invitationButton.addActionListener(al);
      playerList.addActionListener(al);

      exitButton.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            dispose();
         }
      });

      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            dispose();
         }
      });

      pack();        // ̾α â ũ⸦  ũ Ѵ.
      autoAlign();   // ̾α â ũ ߾ ġŲ.
   }

   // ̾α â ũ ߾ ġŲ.
   public void autoAlign() {
      int sw = Toolkit.getDefaultToolkit().getScreenSize().width;
      int sh = Toolkit.getDefaultToolkit().getScreenSize().height;
      int dw = getSize().width;
      int dh = getSize().height;
      int x = (((sw - dw) / 2) < 0) ? 0 : ((sw - dw) / 2);
      int y = (((sh - dh) / 2) < 0) ? 0 : ((sh - dh) / 2);

      setLocation(x, y);
   }
}
