/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

package rndclub.game.godori;
import java.io.*;
import java.net.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.StringTokenizer;

/*
 * κ ִ Ŭ̾Ʈ(÷̾) ϱ   
 * κ񿡼 κ  ִ Ŭ̾Ʈ   뵵 Ѵ.
 *
 * ó Ŭ̾Ʈ 4001Ʈ ϸ PpiKki  ü  ϰ
 *  , κ  ü,   ü  GServerPlayer ü ϰ,
 * ̷  GServerPlayer ü κ  ߰ϰ ȴ.
 * ̶ κ  ü ڽſ ϵ GServerPlayer ü ̿Ͽ
 * ش Ŭ̾Ʈκ Ͱ Դ üũϰ, ̸ óϰ ȴ.
 * Ʈ κ  ü PpiKki Ŭ üڿ ǰ
 * start() ޼ҵ尡 ȣȴ.
 * ,      ̴.
 *
 *    1) PpiKki Ŭ ü
 *         a) Lobby Ŭ ü 
 *              - lobby = new Lobby(); // κ  
 *         b) κ  ü start() ޼ҵ ȣ
 *              - lobby.start();       //   
 *                  -->  ڵ run() ޼ҵ尡 ȣ
 */

public class Lobby extends Thread {
   Hashtable chatList=null;   // κ  ִ Ŭ̾Ʈ Ʈ
                              // (÷̾ ̵, GServerPlayer ü)
   Hashtable roomList=null;   // Լ  Ʈ
                              // (̵, GRoom ü)
   GRoom room=null;           //   ۾ ϱ  ӽ GRoom ü

   public Lobby () {
      chatList = new Hashtable(); // Ŭ̾Ʈ Ʈ  ؽ̺ ü 
      roomList = new Hashtable(); //  Ʈ  ؽ̺ ü 
   }

   //   Ŭ̾Ʈ(GServerPlayer ü) κ ߰Ѵ.
   public void addPlayer(GServerPlayer player) {
      if(player.id != null && chatList.get(player.id) == null){
         int i=0;
         String message=null;

         //   Ŭ̾Ʈ ȯ ޽ .
         message = "410|"+player.id+"|["+player.id+"]  ʽÿ...";
         player.sendMessage(message);     // Ŭ̾ƮԸ ޽ 

         //   Ŭ̾Ʈ  κ  ο ˸.
         message = "400|*|"+player.id+"|["+player.id+"] Ͽϴ..";
         broadcastMessage(message);       // κ  ο ޽ 

         //   Ŭ̾Ʈ Ŭ̾Ʈ Ʈ ߰Ѵ.
         chatList.put(player.id, player);
         Enumeration e = chatList.elements();
         while(e.hasMoreElements()) {
            player = (GServerPlayer)e.nextElement();
            i++;
         }
         // κ ο ŵ  Ʈ .
         broadcastUserList("κ");
      }
   }

   // ־ Ŭ̾Ʈ κ񿡼 Ѵ.
   public void removePlayer(GServerPlayer player) {
      // ־ Ŭ̾Ʈ Ŭ̾Ʈ Ʈ Ѵ.
      chatList.remove(player.id);
      // κ ο ŵ  Ʈ .
      broadcastUserList("κ");
   }

   // ־ ̵ Ŭ̾Ʈ ޽ .
   public void sendMessage(String playerId, String message) {
      GServerPlayer player=null;

      // Ŭ̾Ʈ Ʈ ־ ̵  GServerPlayer ü ´.
      player = (GServerPlayer)chatList.get(playerId);
      if(player != null) {
         // ش ÷̾ ޽ .
         player.sendMessage(message);
      }
   }

   // κ  ο ־ ޽ .
   public void broadcastMessage(String message) {
      GServerPlayer player=null;

      int i=0;
      Enumeration e = chatList.elements();
      while(e.hasMoreElements()) {
         // Ŭ̾Ʈ Ʈ  ִ  Ŭ̾Ʈ
         // GServerPlayer ü  ̸ ̿Ͽ ޽ .
         player = (GServerPlayer)e.nextElement();
         if(player != null) {
            //  ÷̾ ޽ .
            player.sendMessage(message);
         }
      }
   }

   // toIds  ִ ̵  ÷̾𿡰 ޽ .
   // toIds  ÷̾ ̵ ',' ̿Ͽ ϰ ִ.
   public void multicastMessage(String toIds, String fromId, String chatStr) {
      GServerPlayer player=null;

      int i=0;
      // ',' е Ŭ̾Ʈ ̵ ϳ 
      // ̵ شϴ  Ŭ̾Ʈ ޽ .
      StringTokenizer st = new StringTokenizer(toIds, ",");
      while(st.hasMoreTokens()) {
         // toIds ڿ  ִ ̵ ,
         String toId = st.nextToken();    // ̵ ϳ ´.
         String message = "404|"+fromId+"|"+toId+"|"+chatStr;

         //  ̵ شϴ Ŭ̾Ʈ ޽ .
         player = (GServerPlayer)chatList.get(toId);
         player.sendMessage(message);
      }
   }

   // ־ ̵ ÷̾ ش 뿡 ִ  Ʈ .
   public void sendUserList(String playerId, String roomId) {
      GServerPlayer player = null;
      try {
         String message = "450|"+playerId+"|"+roomId+"|";
         if("κ".equals(roomId)) {
            // , κ ִ  Ʈ   

            // κ ü  ִ Ŭ̾Ʈ Ʈ 
            //  Ŭ̾Ʈ Ʈ Ѵ.
            Enumeration e = chatList.elements();
            while(e.hasMoreElements()) {
               // κ ü Ŭ̾Ʈ Ʈκ ̸ ϳ ´.
               player = (GServerPlayer)e.nextElement();
               if(player != null) {
                  message += player.id+",";
               }
            }
         } else {
            // κ ƴ   Ʈ   

            // ش  ü  ִ Ŭ̾Ʈ Ʈ 
            //  Ŭ̾Ʈ Ʈ Ѵ.
            room = (GRoom)roomList.get(roomId);
            for(int i=0;i<room.playerList.size();i++) {
               //  ü Ŭ̾Ʈ Ʈκ ̸ ϳ ´.
               player = (GServerPlayer)room.playerList.elementAt(i);
               message += player.id+",";
            }
         }
         //  Ʈ ϸ鼭  ߰ ','  ؾ Ѵ.
         if(message.endsWith(",")) {
            message = message.substring(0, message.length()-1);
         }

         // ־ ̵  Ŭ̾Ʈ GServerPlayer ü 
         //  Ʈ ޽ Ѵ.
         player = (GServerPlayer)chatList.get(playerId);
         if(player != null) {
            player.sendMessage(message);  // ޽ 
         }

      } catch(Exception e) {
      }
   }

   // ־ ̵ ÷̾  Ʈ .
   public void sendRoomList(String playerId) {
      GServerPlayer player = null;
      int roomNum=0, userNum=0;
      try {
         String message=null;

         if(roomList.isEmpty()) {
            //  Ʈ ִٴ ,    ʾҴٴ ̴.
            roomNum = 1;
            userNum = chatList.size();
         	message = "κ (ο: "+chatList.size()+")";
         } else {
         	message = "κ (ο: "+chatList.size()+"),";

            roomNum = roomList.size() + 1;
            userNum = chatList.size();
            Enumeration e = roomList.elements();
	         while(e.hasMoreElements()) {
               GRoom room = (GRoom)e.nextElement();
	            // ̸, ο, ο   
	            message += room.roomId+" (üο["
	                    + room.playerList.size()
	                    + "]/â["
	                    + room.sessionManList.size() + "]),";
               // ü       
               userNum += room.playerList.size();
	         }
            //  Ʈ ϸ鼭  ߰ ','  ؾ Ѵ.
            if(message.endsWith(",")) {
               message = message.substring(0, message.length()-1);
            }
         }

         // ޽ ϼѴ.
         message = "452|"+playerId+"|"+roomNum+"|"+userNum+"|"+message;

         // ־ ̵  Ŭ̾Ʈ GServerPlayer ü 
         //  Ʈ ޽ Ѵ.
         player = (GServerPlayer)chatList.get(playerId);
         if(player != null) {
            player.sendMessage(message);  // ޽ 
         }
      } catch(Exception e) {
      }
   }

   // κ  ִ ü  Ʈ Ѵ.
   public void broadcastRoomList() {
      GServerPlayer player=null;

      // κ Ŭ̾Ʈ Ʈ  ִ  Ŭ̾Ʈ 
      //  Ʈ  ȴ.
      Enumeration e = chatList.elements();
      while(e.hasMoreElements()) {
         // κ Ŭ̾Ʈ Ʈ ϳ GServerPlayer ü ´.
         player = (GServerPlayer)e.nextElement();
         if(player.id != null && player.room == null) {
            // ش Ŭ̾Ʈ  Ʈ .
            sendRoomList(player.id);
         }
      }
   }

   // κ  ִ ü ־   ִ ڸƮ .
   public void broadcastUserList(String roomId) {
      GServerPlayer player=null;

      // κ Ŭ̾Ʈ Ʈ  ִ  Ŭ̾Ʈ 
      //  Ʈ  ȴ.
      Enumeration e = chatList.elements();
      while(e.hasMoreElements()) {
         // κ Ŭ̾Ʈ Ʈ ϳ GServerPlayer ü ´.
         player = (GServerPlayer)e.nextElement();
         if(player.id != null && player.room == null) {
            // ش Ŭ̾Ʈ    Ʈ .
            sendUserList(player.id, roomId);
         }
      }
   }

   // ־ ̵  Ŭ̾Ʈ
   // ־ ̸ (GRoom ü) Ѵ.
   public void makeRoom(String playerId, String roomId /*, String options*/) {
      GServerPlayer player = (GServerPlayer)chatList.get(playerId);

      // roomId, player  ̿Ͽ  ϱ  GRoom ü Ѵ.
      room = new GRoom(roomId, player);//, options);

      // κ   ִ  Ʈ    ü ߰Ѵ.
      roomList.put(roomId, room);

      for(int i=0;i<room.playerList.size();i++) {
         player = (GServerPlayer)room.playerList.elementAt(i);
      }

      //   ü   ִ Ŭ̾Ʈκ  ͸
      // ֱ üũؾ ϹǷ, μ Ѵ.
      // ,   ü  Ŀ ݵ start() ޼ҵ ȣϿ
      // 带 ۽ ־ Ѵ.
      room.start();
   }

   // ־ ÷̾ κ񿡼  Ͽ    óѴ.
   public void enterRoom(String playerId, String roomId) {
      // ־ ̵ (GRoom) ü ´.
      GRoom room = (GRoom)roomList.get(roomId);

      if(room != null) {
         GServerPlayer player = (GServerPlayer)chatList.get(playerId);
         // κ ü Ŭ̾Ʈ Ʈ ־ ÷̾  ,
         removePlayer(player);

         //  ü Ŭ̾Ʈ Ʈ ߰Ѵ.
         room.addPlayer(player);

         // Ŭ̾Ʈ κ񿡼  ̵Ƿ,
         // κ  ο ־     ֵ Ѵ.
         broadcastUserList(roomId);
      } else {
      }
   }

   // ־ ̵  κ ü  Ʈ Ѵ.
   public void removeRoom(String roomId /*, String options*/) {
      // ־ ̵ (GRoom) ü ´.
      GRoom room = (GRoom)roomList.get(roomId);

      if(room != null) {
         for(int i=0;i<room.playerList.size();i++) {
            //  ü Ŭ̾Ʈ Ʈ ִ  Ŭ̾Ʈ 뿡 Ѵ.
            GServerPlayer player = (GServerPlayer)room.playerList.elementAt(i);
            room.removePlayer(player.id);
         }
         // κ ü ִ  Ʈ ־ ̵  ü Ѵ.
         roomList.remove(roomId);
         room = null;

         //  ŵǾǷ, κ  ο  Ʈ ϵ Ѵ.
         broadcastRoomList();
      }
   }

   // ־ ̵ شϴ Ŭ̾Ʈ   Ѵ.
   //  (profile): "sex,age,win,lose,total,position"
   public void setProfile(String playerId, String profile) {
      // profile ڿ "point,sex,age,win,lose,total,position"  .

      GServerPlayer player = null;
      try {
         // ־ ̵ GServerPlayer ü ´.
         player = (GServerPlayer)chatList.get(playerId);
         if(player != null) {
            // ,   ϳ   
            // ⼭ ǹϴ.  ʴ´.

            StringTokenizer st = new StringTokenizer(profile, ",");

            try {
               // ù° point  ´.
               player.point = Integer.parseInt(st.nextToken());
            } catch(Exception e) {
            }
            player.sex = st.nextToken();        // ι° sex  ´.
            player.age = st.nextToken();        // ° age  ´.
            player.win = st.nextToken();        // ׹° win  ´.
            player.lose = st.nextToken();       // ټ° lose  ´.
            player.total = st.nextToken();      // ° total  ´.
            player.position = st.nextToken();   // ϰ° position  ´.

            // κ  ο ־ ̵  Ŭ̾Ʈ
            //    ޽ Ѵ.
            broadcastMessage("470|"+playerId+"|"+profile);
         }
      } catch(Exception e) {
      }
   }

   // ־ ̵ Ŭ̾Ʈ  GServerPlayer ü ´.
   public GServerPlayer getPlayer(String playerId) {
      GServerPlayer player=null;

      // κ  Ŭ̾Ʈ Ʈ ־ ̵ Ŭ̾Ʈ ִ Ȯ
      player = (GServerPlayer)chatList.get(playerId);
      if(player != null) {
         // κ  ־ ̵ Ŭ̾Ʈ  
         return(player);
      }

      // κ  ־ ̵ Ŭ̾Ʈ  
      //  Ʈ ִ  ü  ־ Ѵ.
      if(roomList.isEmpty()) {
         //  ϳ  ־ ̵ Ŭ̾Ʈ  ̴.
         return(null);
      } else {
         //   ,  뿡 ־ ̵ Ŭ̾Ʈ ִ ã´.
         Enumeration e = roomList.elements();
         while(e.hasMoreElements()) {
            GRoom room = (GRoom)e.nextElement();

            player = room.getPlayer(playerId);
            if(player != null) {
               //  뿡 ־ ̵ Ŭ̾Ʈ ã 
               return(player);
            }
         }
      }

      // κ񿡵  뿡 ־ ̵ Ŭ̾Ʈ  ̴.
      return(null);
   }

   // ־ ̵(who) Ŭ̾Ʈ    
   // ־ ̵  Ŭ̾Ʈ(to)   Ŭ̾Ʈ .
   public void sendProfile(String to, String who) {
      GServerPlayer whoPlayer=null, toPlayer=null;
      try {
         // ־ ̵(who) Ŭ̾Ʈ ü ´.
         whoPlayer = getPlayer(who);

         // ־ ̵(to) Ŭ̾Ʈ ü ´.
         toPlayer = getPlayer(to);

         if((whoPlayer != null)&&(toPlayer != null)) {
            //   null  ƴ , ޽ ùٸ Ѵ.
            String profileMessage = "472|"+to+"|"+who+"|"+whoPlayer.getProfileMessage();

            toPlayer.sendMessage(profileMessage);
         } else {
            // who null̰ to null ƴϸ,
            // Ʈ ޽("**^____^**"") to ..
            if((whoPlayer == null)&&(toPlayer != null)) {
               String profileMessage = "472|"+to+"|"+who+"|**^____^**";

               toPlayer.sendMessage(profileMessage);
            }
         }
      } catch(Exception e) {
      }
   }

   // ־ ̵(who) Ŭ̾Ʈ    
   // ־ ̵  Ŭ̾Ʈ(to)   Ŭ̾Ʈ .
   public void sendPlayerInfo(String to, String who) {
      GServerPlayer whoPlayer=null, toPlayer=null;
      try {
         // ־ ̵(who) Ŭ̾Ʈ ü ´.
         whoPlayer = getPlayer(who);

         // ־ ̵(to) Ŭ̾Ʈ ü ´.
         toPlayer = getPlayer(to);
         if((whoPlayer != null)&&(toPlayer != null)) {
            //   null  ƴ , ޽ ùٸ Ѵ.
            String playerInfoMessage = "474|"+to+"|"+who+"|";

            playerInfoMessage += whoPlayer.getPlayerInfoMessage();

            toPlayer.sendMessage(playerInfoMessage);
         } else {
            // who null̰ to null ƴϸ,
            // Ʈ ޽("**^____^**"") to ..
            if((whoPlayer == null)&&(toPlayer != null)) {
               String playerInfoMessage = "474|"+to+"|"+who+"|**^____^**";

               toPlayer.sendMessage(playerInfoMessage);
            }
         }
      } catch(Exception e) {
         e.printStackTrace();
      }
   }

   // 뿡 ִ Ŭ̾Ʈ ٽ Ƿ ƿ  ,
   //  Ŭ̾Ʈ Ʈ ش Ŭ̾Ʈ ٽ ߰Ѵ.
   public void takePlayer(GServerPlayer player) {
      int i=0;

      //  Ŭ̾Ʈ Ʈ ش Ŭ̾Ʈ ٽ ߰Ѵ.
      chatList.put(player.id, player);

      //   ڵ  ߰Ǿ   ڵ̴.
      Enumeration e = chatList.elements();
      while(e.hasMoreElements()) {
         player = (GServerPlayer)e.nextElement();
         i++;
         System.out.println("IIIIII:::["+i+"]");
      }
   }

   /*
    * κ ִ Ŭ̾Ʈ(÷̾) ϱ   
    * κ񿡼 κ  ִ Ŭ̾Ʈ   뵵 Ѵ.
    *
    * ó Ŭ̾Ʈ 4001Ʈ ϸ PpiKki  ü  ϰ
    *  , κ  ü,   ü  GServerPlayer ü ϰ,
    * ̷  GServerPlayer ü κ  ߰ϰ ȴ.
    * ̶ κ  ü ڽſ ϵ GServerPlayer ü ̿Ͽ
    * ش Ŭ̾Ʈκ Ͱ Դ üũϰ, ̸ óϰ ȴ.
    * Ʈ κ  ü PpiKki Ŭ üڿ ǰ
    * start() ޼ҵ尡 ȣȴ.
    * ,      ̴.
    *
    *    1) PpiKki Ŭ ü
    *         a) Lobby Ŭ ü 
    *              - lobby = new Lobby(); // κ  
    *         b) κ  ü start() ޼ҵ ȣ
    *              - lobby.start();       //   
    *                  -->  ڵ run() ޼ҵ尡 ȣ
    */
   public void run() {
      int ccc=0;

      // κ   ü Ŭ̾Ʈ Ʈ ϵǾ ִ 
      // Ŭ̾Ʈκ  ޽ ֱ üũϿ о´.
      // , μ ϸ, ѷ ´.
      while(true) {
         // Read Data
         try {
            // CPU (Ǵ )ϴ 尡 Ǵ  ϱ  
            // ̸ ش.
            sleep(100);
         } catch(InterruptedException ie) {
         }

         // Ŭ̾Ʈ Ʈ ϵǾ ִ Ŭ̾Ʈ ü ϳ 
         //  chatList ؽ̺κ Enumeration ü ´.
         Enumeration e = chatList.elements();
         int iii=0;
         ccc++;
         while(e.hasMoreElements()) {
            // Enumeration üκ ϳ Ŭ̾Ʈ ü ´. 
            GServerPlayer player = (GServerPlayer)e.nextElement();
            iii++;
            try {
               String receive = null;

//  Ŭ̾Ʈκ ͸ о´.
//  ,  Ŭ̾Ʈκ Ͱ  
//  ٸ(ŷ)  ƴ϶
// SO_TIME   ð(10msec) 
// Ͽ о̱  ŷ    ȴ.
// ׷,  Ŭ̾Ʈκ ͸ о  ִ.
               receive = player.receiveMessage();

// player.receiveMessage() ޼ҵ    .
//   1) Ŭ̾Ʈ  : SocketException or IOException  ߻
//                              try {
//                                 ...
//                              } catch(SocketException e) {
//                                  κп ش  ó
//                                   - Ʈ Ѵ.
//                              } catch(IOException e) {
//                                  κп ش  ó
//                                   - Ʈ Ѵ.
//                              }
//   2) null Ǵ ""  : Ŭ̾Ʈκ  Ͱ ų
//                            Ǵ, SO_TIME  ð  
//   3) ڿ : Ŭ̾Ʈκ  ͸  

//     쿡  óϴ ̴.

// 1)   ó  Ʒ ִ catch(...)  óѴ.
// 2) Ŭ̾Ʈκ ޵ Ͱ  
               if(receive == null || "".equals(receive)) {
                  continue;
               }

// 3) Ŭ̾Ʈκ ͸  о 
//     ݿ  ͸ óѴ.

               // Godori Protocol
               // command|arg1|arg2|arg3|...
               StringTokenizer st = new StringTokenizer(receive, "|");
               String command = st.nextToken();
               if(command.startsWith("300")) {
                  // 300
                  //   Desc: κ   Ŭ̾Ʈ ޽ εĳ
                  //   Comm: 300|fromId|*|chatMessage
                  String fromId = st.nextToken();
                  String toId=st.nextToken();
                  String chatStr = st.nextToken();

                  String message = "400|"+fromId+"|*|["+fromId+"] "+chatStr;
                  broadcastMessage(message);
               } else if(command.startsWith("302")) {
                  // 302
                  //   Desc: κ  Ưο ޽  (ӼӸ)
                  //   Comm: 302|fromId|toId|chatMessage
                  String fromId = st.nextToken();
                  String toId = st.nextToken();
                  String chatStr = st.nextToken();

                  String message = "402|"+fromId+"|"+toId+"|["+fromId+"] "+chatStr;

                  sendMessage(toId, message);   // κ  εĳ
               } else if(command.startsWith("310")) {
                  // 310
                  //   Desc:  , Ŭ̾Ʈ Ӱ 
                  //   Comm: 310|fromId
                  String fromId = st.nextToken();
                  player.id = fromId;

                  addPlayer(player);   // Ŭ̾Ʈ ߰
               } else if(command.startsWith("320")) {
                  // 320
                  //   Desc: ־ Ŭ̾Ʈ ó
                  //   Comm: 320|fromId
                  String fromId = st.nextToken();

                  // Ŭ̾Ʈ  ޽ εĳ
                  String message = "400|"+fromId+"|*|["+fromId+"] ϼ̽ϴ.";
                  broadcastMessage(message);

                  //  Ŭ̾Ʈ ߰ ޽ 
                  message = "420|"+fromId+"|["+fromId+"] ȳ .";
                  sendMessage(fromId, message);
               } else if(command.startsWith("350")) {
                  // 350
                  //   Desc: κ   Ʈ û Ŭ̾Ʈ Ѵ.
                  //   Comm: 350|fromId|RoomId
                  String fromId = st.nextToken();
                  String roomId = st.nextToken();
                  // Send User List in the specified room
                  sendUserList(fromId, roomId);
               } else if(command.startsWith("352")) {
                  // 352
                  //   Desc:  Ʈ û Ŭ̾Ʈ Ѵ.
                  //   Comm: 352|fromId
                  String fromId = st.nextToken();

                  // Send Room List
                  sendRoomList(fromId);
               } else if(command.startsWith("360")) {
                  // 360
                  //   Desc:  ϰ,  Ʈ Ѵ.
                  //   Comm: 360|fromId|roomId
                  String fromId = st.nextToken();
                  String roomId = st.nextToken();
            //      GServerPlayer player=(GServerPlayer)chatList.get(playerId);
                  //String options = st.nextToken();

                  makeRoom(fromId, roomId/*, options*/);
                  String message = "460|"+fromId+"|"+roomId;  // 游 
                  sendMessage(fromId, message);

                  enterRoom(fromId, roomId/*, options*/);

                  broadcastRoomList();
               } else if(command.startsWith("362")) {
                  // 362
                  //   Desc: ǿ   óѴ.
                  //   Comm: 362|fromId|roomId|Id1,Id2,Id3
                  String fromId = st.nextToken();
                  String roomId = st.nextToken();
                  String message = "462|"+fromId+"|"+roomId;  //+"|"  Ʈ ߰
                  sendMessage(fromId, message);

                  enterRoom(fromId, roomId);

                  // ش  ü(room) ޼ҵ带 ̿Ͽ   ִ
                  /// Ŭ̾Ʈ  Ȳ Ѵ.
                  room.informPlayerList(player);
                  room.reportLive(player);
                  room.reportCurrentPlayer();
               } else if(command.startsWith("366")) {
                  // 366
                  //   Desc:  ɼ Ѵ. -   
                  //   Comm: 366|fromId|roomId|Options
                  String fromId = st.nextToken();
                  String roomId = st.nextToken();
                  //String options = st.nextToken();

                  //setOption(fromId, roomId, options);
                  broadcastMessage("466|"+fromId+"|"+roomId); //+"|"+options);
               } else if(command.startsWith("370")) {
                  // 370
                  //   Desc: û Ŭ̾Ʈ   Ѵ.
                  //   Comm: 370|fromId|sex,age,win,lose,total,position

                  String fromId = st.nextToken();
                  String profile = st.nextToken();

                  setProfile(fromId, profile);
               } else if(command.startsWith("372")) {
                  // 372
                  //   Desc: û Ŭ̾Ʈ   .
                  //   Comm: 372|fromId|who
                  String fromId = st.nextToken();
                  String who = st.nextToken();
                  //String options = st.nextToken();

                  sendProfile(fromId, who);
               } else if(command.startsWith("374")) {
                  // 374
                  //   Desc: û Ŭ̾Ʈ   .
                  //   Comm: 374|fromId|who
                  String fromId = st.nextToken();
                  String who = st.nextToken();

                  sendPlayerInfo(fromId, who);
               } else if(command.startsWith("388")) {
                  // 388
                  //   Desc: GClient û  (REFUSE)/(JOIN) ϱ
                  //   Comm: 388|fromId(GClientLobby)|toId(GClient)|roomId|[JOIN|REFUSE]
                  try {
                     String fromId = st.nextToken();
                     String toId = st.nextToken();
                     String roomId = st.nextToken();
                     String joinRefuse = st.nextToken();

                     String message = "688|"+fromId+"|"+toId+"|"+roomId+"|"+joinRefuse;

                     // ٸ Ŭ̾Ʈκ û 
                     //  Ǵ  ޽ .
                     GRoom room = (GRoom)roomList.get(roomId);
                     player = (GServerPlayer)room.getPlayer(toId);
                     player.sendMessage(message);
                  } catch(Exception ee) {
                  }
               }
            } catch(SocketException ne) {
               // 1)    óѴ.
               // Ŭ̾Ʈ Ʈŷ  ̹Ƿ,
               // ݵ ش Ŭ̾Ʈ κ񿡼 ؾ Ѵ.
               removePlayer(player);
            } catch(IOException ne) {
               // 1)    óѴ.
               // Ŭ̾Ʈ Ʈŷ  ̹Ƿ,
               // ݵ ش Ŭ̾Ʈ κ񿡼 ؾ Ѵ.
               removePlayer(player);
            }
         }
      }
   }
}
