<%@ page contentType="text/html;charset=EUC-KR" %>
<%@ page errorPage="/guestbook/ErrorPage.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="org.rndclub.guestbook.*" %>

<jsp:useBean id="gbProcess" class="org.rndclub.guestbook.GuestBookProcess" scope="session"/>

<%
  int pageNum=1;
  try {
    pageNum = Integer.parseInt(request.getParameter("pageNum"));
  } catch(NumberFormatException e) {
  }

  gbProcess.setRowPerPage(10);
  ArrayList gbList = gbProcess.selectPage(pageNum);
%>

<html>
<head>
  <title></title>
  <style type=text/css>
  <!--
    A:link{font:10pt ,Arial;COLOR:#0000A0;text-decoration:none
    A:active{font:10pt ,Arial;COLOR:#0000A0;text-decoration:none
    A:visited{font:10pt ,Arial;COLOR:#0000A0;text-decoration:none
    td{font:10pt ,Arial;COLOR:#000000;text-decoration:none
  -->
  </style>
</head>

<body bgcolor=#F5EDE8 text=black
      link=blue vlink=purple alink=red
      topmargin=0 leftmargin=0 marginwidth=0 marginheight=0>

<!-- Header -->
<%@ include file="/guestbook/HeaderPage.jsp" %>

<!-- Body -->
<table border=0 cellpadding=4 cellspacing=1 width=600>
  <tr>
    <td align=left valign=bottom><font size=2 color=brown>
      Item: <%= (pageNum-1)*gbProcess.getRowPerPage() %>/
            <%= gbProcess.getNumberOfRow() %>,&nbsp;&nbsp; 
      Page: <%= pageNum %>/<%= gbProcess.getNumberOfPage() %>
    </td>
    <td align=right>
      <a href="/rndclub/guestbook/GuestBookInputForm.jsp">
        <img src="/rndclub/guestbook/images/write.gif" border=0></a>
    </td>
  </tr>
</table>
<table border=0 cellpadding=0 cellspacing=1 width=600>
  <tr>
    <th width=10% height=25 align=center bgcolor=#9FAF9F>
      <p><font size=2 color=white>ȣ</font></th>
    <th width=50% align=center bgcolor=#9FAF9F>
      <p><font size=2 color=white></font></th> 
    <th width=15% align=center bgcolor=#9FAF9F>
      <p><font size=2 color=white>ۼ</font></th>       
    <th width=15% align=center bgcolor=#9FAF9F>
      <p><font size=2 color=white>ۼ</font></th>
    <th width=10% align=center bgcolor=#9FAF9F>
      <p><font size=2 color=white>Ƚ</font></th>
  </tr>
<%
  for(int i=0;i<gbList.size();i++) {
    GuestBookBean gb = (GuestBookBean)gbList.get(i);
%>
  <tr>
    <td align=center><p><font size=2><%=gb.getId()%></font></td>
    <td><p><font size=2>
      <A HREF="/rndclub/guestbook/GuestBookComment.jsp?id=<%= gb.getId() %>&pageNum=<%= pageNum %>">
        <%= gb.getSubject() %></A></font></td>
    <td align=center><p><font size=2>
      <A HREF="mailto:<%= gb.getEmail() %>"><%= gb.getName() %></font></td>
    <td align=center><p><font size=2><%= gb.getWriteDate() %></font></td>
    <td align=center><p><font size=2><%= gb.getRefCount() %></font></td>
  </tr>
<%
  } // end of for
%>
</table>
<table border=0 width=600>
  <tr align=center>
    <td bgcolor=#cccccc>

<%
  if(gbProcess.availablePrevPage(pageNum)) {
%>
      <a href="/rndclub/guestbook/GuestBookList.jsp?pageNum=<%= (pageNum-1) %>">
        <img src="/rndclub/guestbook/images/back.gif"
             border=0 alt= align=absmiddle></a>
<%
  } else {
%>
      <img src="/rndclub/guestbook/images/back.gif"
           border=0 alt= align=absmiddle>
<%
  }

  if(gbProcess.availableNextPage(pageNum)) {
%>
      <a href="/rndclub/guestbook/GuestBookList.jsp?pageNum=<%= (pageNum+1) %>">
        <img src="/rndclub/guestbook/images/next.gif"
             border=0 alt= align=absmiddle></a>
<%
  } else {
%>
      <img src="/rndclub/guestbook/images/next.gif"
           border=0 alt= align=absmiddle>
<%
  }
%>
    </td>
  </tr>
  <tr>
    <td BGCOLOR=#EFEFDF>&nbsp;</td>
  </tr>
</table>
</center>

<!-- Footer -->
<%@ include file="/guestbook/FooterPage.jsp" %>

</body>
</html>
