package org.rndclub.godori;

/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

import java.awt.*;
import java.awt.event.*;

// ǻ 뿡  ˻  ֱ  ̾α â̴.
class SearchDialog extends Dialog {
   Button okButton=null;
   Label msgLabel=null;
   Label idLabel = null;
   Label roomLabel = null;
   Label statusLabel = null;

   public SearchDialog(Frame owner, String title, String message,
                       String searchId, String roomId, String status) {
      super(owner, title, true);

      setLayout(new BorderLayout());
      setBackground(new Color(131,131,131));
      msgLabel = new Label(message);
      msgLabel.setAlignment(Label.CENTER);
      msgLabel.setForeground(Color.blue);

      okButton = new Button("Ȯ");
      okButton.setBackground(new Color(184,184,218));

      Panel p2 = new Panel(new GridLayout(3,1));
      p2.setBackground(new Color(131,131,131));

      if(!"**^____^**".equals(message)) {
         // , ˻ 밡   ش  ش.
         idLabel = new Label("˻̵: " + searchId, Label.LEFT);
         roomLabel = new Label(" : "+ roomId, Label.LEFT);
         statusLabel = new Label(" : "+ status, Label.LEFT);

         p2.add(idLabel);
         p2.add(roomLabel);
         p2.add(statusLabel);
      } else {
         // , ˻ 밡   ش ޽ ش.
         idLabel = new Label("["+searchId+"]   ʽϴ.", Label.CENTER);

         p2.add(idLabel);
      }
      Panel p = new Panel();
      p.setBackground(new Color(235,235,206));
      p.add(okButton);

      add("North", msgLabel);
      add("Center",p2);
      add("South", p);

      // "OK" ư Ŭϸ ̾α â ݰ .
      okButton.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            dispose();
         }
      });

      // ̾α â ݱ ư Ŭϸ ̾α â ݰ .
      addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
            dispose();
         }
      });

      pack();        // ̾α â ũ⸦  ũ 
      autoAlign();

      // ˻  â Ÿ ¿ Ű ĵ
      // ٷ   ֵ "OK" ư Է Ŀ ش.
      okButton.requestFocus();
   }

   // ̾α â ũ ߾ ġŲ.
   public void autoAlign() {
      int sw = Toolkit.getDefaultToolkit().getScreenSize().width;
      int sh = Toolkit.getDefaultToolkit().getScreenSize().height;
      int dw = getSize().width;
      int dh = getSize().height;
      int x = (((sw - dw) / 2) < 0) ? 0 : ((sw - dw) / 2);
      int y = (((sh - dh) / 2) < 0) ? 0 : ((sh - dh) / 2);

      setLocation(x, y);
   }
}
