package org.rndclub.godori;

/*
 * Copyright (c) 2000 Yongwoo's Park. All Rights Reserved.
 */

import java.awt.*;

//  ġ   ¸ Ÿ ޽ ֱ  â̴.
class StatusDialog extends Dialog {
   String message="";
   int delayTime=0;

   public StatusDialog(Frame owner, String title, String message) {
      super(owner, title, false);

      setLayout(null);

	   setBackground(new Color(31,119,0));
      setSize(480, 240);

      //  ̾α â  () ߾ӿ ġŲ.
      int wid = this.getParent().getSize().width;
      int hei = this.getParent().getSize().height;
      int w = this.getSize().width;
      int h = this.getSize().height;
      setLocation(((wid - w)/2),((hei - h)/2));
   }

   public void setMessage(String message, int delayTime) {
      this.message = message;
      this.delayTime = delayTime;

      repaint();
   }

   // ޽ ̾α â ߾ӿ ش.
   public void paint(Graphics g) {
      int boardX=0, boardY=0;
      int boardWidth=getSize().width, boardHeight=getSize().height;

      // ޽  Ʈ Ѵ.
      Font f = new Font("Batang", Font.BOLD, 16);
      FontMetrics fm = getFontMetrics(f);;

      // ޽ ũ⸦ Ͽ ޽ ߾ӿ ̵ ǥ Ѵ.
      int messageWidth = fm.stringWidth(message);
      int messageHeight = fm.getHeight();

      int rectX = ((boardWidth - messageWidth) / 2) - 20;
      int rectY = ((boardHeight - messageHeight) / 2) - 20;
      int rectWidth = messageWidth + 20 * 2;
      int rectHeight = messageHeight + 20 * 2;

      //  ڽ ׸   ޽ ϱ 
      g.setColor(new Color(153,140,10));
      g.fillRect(rectX, rectY, rectWidth, rectHeight);    //   ׸

      g.setColor(Color.blue);
      for(int b=0;b<4;b++) {         // ׵θ ڽ ׸
         g.drawRect(rectX+b, rectY+b, rectWidth-b*2-1, rectHeight-b*2-1);
      }

      //   ߾ӿ ޽ ׸.
      int drawX = ((boardWidth - messageWidth) / 2);
      int drawY = ((boardHeight - messageHeight) / 2) + fm.getAscent();

      g.setFont(f);
      g.drawString(message, drawX, drawY);

      try {
         Thread.sleep(delayTime);  // (delayTime / 1000)   ٸ.
      } catch(Exception e) {
      }
   }
}
