package rndclub.game.shinkyoungshoiyak;
import java.awt.*;

// ̹ Ÿ  ImageCanvas Ʈ Ӱ 
class ImageCanvas extends Canvas {
   // ӿ Ǵ ̹   ¸ 
   final static int STATE_FRONT=0;   // ̹ ̴ ¸ Ÿ 
   final static int STATE_BACK=1;   //  ¸ Ÿ 
   final static int INVALID_ID=-1;    // ̹   ¸ Ÿ 

   Image image=null;
   int id=INVALID_ID;
   int state=STATE_BACK;   // 

   public ImageCanvas() {
      this(INVALID_ID, null);
   }

   // ̵ ̹ ̿Ͽ ̹ Ʈ 
   public ImageCanvas(int id, Image image) {
      this.id = id;
      this.image = image;

      state = STATE_BACK;  // ÿ  · ǥ
      setBackground(new Color(0xef, 0xf8, 0xff));   //  
   }

   // ־ ̹ Ʈ  ̹  ִ  ˻
   public boolean equals(Object o) {
      // Ű ޵ ü ImageCanvas νϽ 쿡  
      if((o != null)&&(o instanceof ImageCanvas)) {
         ImageCanvas p = (ImageCanvas)o;
         if(p.getId() == this.id) {
            return(true);
         }
      }
      return(false);
   }

   // ̹ Ʈ  (ո/޸) Ѵ.
   public int getState() {
      return(state);
   }

   // ̹ Ʈ  (ո/޸) Ѵ.
   public void setState(int state) {
      this.state = state;
      repaint();
   }

   // ̹ Ʈ  (ո/޸) ݴ · Ѵ.
   public void reverseState() {
      if(state == STATE_FRONT) {
         state = STATE_BACK;
      } else {
         state = STATE_FRONT;
      }
      repaint();
   }

   // ̹ Ʈ  ̹ id  Ѵ.
   public int getId() {
      return(id);
   }

   // ̹ Ʈ  ̹ id  Ѵ.
   public void setId(int id) {
      this.id = id;
   }

   //  ̹ Ѵ.
   public Image getImage() {
      return(image);
   }

   // ̹ Ѵ.
   public void setImage(Image image) {
      this.image = image;
   }

   // repaint() ޼ҵ带 Ͽ   
   public void repaint() {
      System.out.println("repaint");
      paint(getGraphics());
   }

   // update() ޼ҵ带 Ͽ   
   public void update(Graphics g) {
      System.out.println("update");
      paint(g);
   }

   //  ¿  ̹(ո) Ǵ (޸) ڽ ׷ش.
   public void paint(Graphics g) {
      System.out.println("paint-gate");
      if(g == null) return;

      int width = getSize().width;
      int height = getSize().height;

      if((image != null)&&(state == STATE_FRONT)) {
         System.out.println("paint-STATE_FRONT");
         // image null ƴϰ, Ʈ ° ո  ̹ ׸.
         g.drawImage(image, 0, 0, width, height, this);
      } else {
         System.out.println("paint-STATE_BACK");
         // image null̰ų, Ʈ ° ޸  ڽ ׸.
         g.setColor(getBackground());           //  ڽ ׸
         g.fillRect(0, 0, width-1, height-1);
         g.setColor(Color.black);               //  ڽ ׸
         g.drawRect(0, 0, width-1, height-1);
      }
   }
}
